---
schema_version: "1"
id: 5dfc217c207f88d33f3966d3e08d2ac5ec5270c30bfc172e596da38d3fcf5b41
title: Data Product Search (deprecated)
collection: developer
version: current
locale: en-us
portal_url: https://docs.salesforce.com/developer/current/en-us/commerce-cloud/b2c-commerce/references/generated-api-specs/ocapi-data-product-search.md
canonical_url: https://developer.salesforce.com/docs/commerce/b2c-commerce/references/ocapi-data-product-search
source_site: developer.salesforce.com
content_type: documentation
content_hash: 09c623199373563cbde40103e035866203628bd0f0d2b3998355387e8546a385
products:
  - B2C Commerce
  - Salesforce APIs
---
Data Product Search (deprecated)

# Data Product Search (deprecated)

Data API endpoints enable developers to build applications for merchants: Create, update, delete business objects, like products, customers, pricing and promotions or assignments. They typically provide read and write access and are designed for moderate usage.

**Version:** 25.6

## Servers

*   `https://{host}/s/-/dw/data/v25_6`

Protocols: https.

## Security

*   `oauth2_application` (oauth2) Authentication flow with client ID and password with account manager.
    *   OAuth flow application (tokenUrl: https://account.demandware.com:443/dwsso/oauth2/access\_token)
    *   Scope x-info: Scopes are NOT supported. This is just a dummy, because the 'scopes' field is required.
*   `client_id` (apiKey) Add client ID for application identification. Alternative as 'client\_id' query parameter.
    *   API key in header: x-dw-client-id

## Operations

### POST Search Products

`POST /product_search`

Operation ID: `Search Products`. Tags: product\_search. Security: oauth2\_application.

Searches for products.

Note: This resource does not return information about product master and product variation relationships. Use the ProductSearch SHOP API resource to retrieve more details about product relationships.

The query attribute specifies a complex query that can be used to narrow down the search. Attributes are grouped into different buckets. These are the list of searchable attributes with their corresponding buckets:

Main:

*   id - String
    
*   name - String
    
*   online - SiteSpecific Boolean
    
*   searchable - SiteSpecific Boolean
    
*   valid\_from - SiteSpefic DateTime
    
*   valid\_to - SiteSpecfic DateTime
    
*   type - ProductType
    
*   creation\_date - DateTime
    
*   last\_modified - DateTime
    

Catalog:

*   catalog\_id - String
    

Category:

*   category\_id - String
    

Special:

*   type - {"item", "set, "bundle", "master", "part\_of\_product\_set", "bundled", "variant", "variation\_group", "option", "retail\_set", "part\_of\_retail\_set"}
    

The sortable properties are:

*   id - String
    
*   name - String
    
*   creation\_date - DateTime
    

When you specify a catalog\_id or category\_id, only products explicitly assigned to that catalog or category are returned. For example, if a product with variants is assigned to a catalog, but its variants are not, searching on that catalog\_id only returns the main product, not the variants. This behavior is different from that of the product search in Business Manager, which returns products that inherit the selected catalog or category assignment.

Only attributes in the same bucket can be joined using a disjunction (OR). For instance, when joining id and catalog\_id above, only a conjunction is allowed (AND), whereas id and searchable can be joined using a disjunction because they are in the same bucket. If an attribute is used in a disjunction (OR) that violates this rule, an exception will be thrown.

The product search retrieves additional properties of the product when expansions are used. The available expand attribute values are:

*   'all' will retrieve all the product properties.
    
*   'availability' will retrieve the following properties:
    
    *   ats
        
    *   in\_stock
        
    *   online
        
*   'categories' will retrieve the following properties:
    
    *   assigned\_categories
        
*   'images' will retrieve the following properties:
    
    *   image
        
*   'all\_images' used with images will retrieve the following properties:
    
    *   image
        
    
    *   image\_groups
        
*   'prices' will retrieve the following properties:
    
    *   price
        
    *   price\_currency
        
*   'sets' will retrieve the following properties:
    
    *   set\_products
        
    *   product\_sets
        
*   'bundles' will retrieve the following properties:
    
    *   product\_bundles
        
    *   bundled\_products
        

This endpoint may return the following faults:

*   400 - MalformedSearchParameterException - Indicates the search query is ill-formed.

#### Parameters

*   `site_id` (query, string) The site context.

#### Request body

Media type: `application/json, text/xml`. Schema: `search_request`.

#### Responses

*   **400** `MalformedSearchParameterException` - Indicates the search query is ill-formed.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `product_search_result`.
    

## Schemas

### search\_request

Document representing a search request for retrieving items within the Data API. The query is a potentially complex set of expressions. The fields that each query supports are defined within the search resource.

*   `count` (_integer (int32)_) The number of returned documents  
    Minimum: 1. Maximum: 200.
*   `db_start_record_` (_integer (int32)_) The zero-based index of the record that we want to start with, used to optimize special handling  
    Minimum: 0.
*   `expand` (_array of string_) List of expansions to be applied to each search results. Expands are optional
*   `query` (_query_, required) The query to apply
*   `select` (_string_) The field to be selected.
*   `sorts` (_array of sort_) The list of sort clauses configured for the search request. Sort clauses are optional.
*   `start` (_integer (int32)_) The zero-based index of the first search hit to include in the result.  
    Minimum: 0.

### fault

Document representing a fault message that is returned whenever the HTTP status code is greater than or equal to 400 (which indicates an error).

*   `arguments` (_object_)
    
    A map that provides fault arguments.
    
    Data can be used to provide error messages on the client side.
    
    Additional properties: `object`.
    
*   `cause` (_cause_)
*   `display_message_pattern` (_string_) The localized display message pattern, if the request parameter display\_locale was given
*   `message` (_string_) The message text of the java exception.
*   `stack_trace` (_string_)
*   `type` (_string_) The name of the java exception.

### product\_search\_result

Document representing a product search result.

*   `count` (_integer (int32)_) The number of returned documents
*   `data` (_array of object_)
*   `db_start_record_` (_integer (int32)_) The zero-based index of the record that we want to start with, used to optimize special handling  
    Minimum: 0.
*   `expand` (_array of string_) List of expansions to be applied to each search results. Expands are optional
*   `hits` (_array of product_) The sorted array of search hits. Can be empty.
*   `next` (_result\_page_) The data that can be used (as parameters on the search request) to retrieve the next result page.
*   `previous` (_result\_page_) The data that can be used (as parameters on the search request) to retrieve the previous result page.
*   `query` (_query_) The query passed into the search
*   `select` (_string_) The field to be selected.
*   `sorts` (_array of sort_) The list of sort clauses configured for the search request. Sort clauses are optional.
*   `start` (_integer (int32)_) The zero-based index of the first search hit to include in the result.  
    Minimum: 0.
*   `total` (_integer (int32)_) The number of returned documents

_Example_

```
{
  "count": 2,
  "hits": [
    {
      "brand": "Brand",
      "id": "my-product",
      "link": "https://example.com/s/-/dw/data/{version}/products/my-product",
      "long_description": {
        "default": "Long Description"
      },
      "manufacturer_name": "main manufacturer",
      "manufacturer_sku": "main manufacturer ID",
      "name": {
        "default": "Main"
      },
      "online": {
        "default": true
      },
      "owning_catalog_id": "my-catalog",
      "owning_catalog_name": {
        "default": "My Catalog"
      },
      "price": 100,
      "price_currency": "USD",
      "price_per_unit": 100,
      "searchable": {
        "default": true
      },
      "short_description": {
        "default": "Short Description"
      },
      "type": {
        "bundled": true,
        "master": true,
        "part_of_product_set": true
      },
      "unit": "mst",
      "unit_measure": "each",
      "unit_quantity": 1,
      "upc": "WapiMain UPC"
    },
    {
      "brand": "QA",
      "id": "my-product2",
      "in_stock": true,
      "link": "https://example.com/s/-/dw/data/{version}/products/my-product2",
      "name": {
        "default": "Offline Categorized Variant 2"
      },
      "online": {
        "default": true
      },
      "searchable": {
        "default": true
      },
      "short_description": {
        "default": "Offline and categorized variant in offline master."
      },
      "type": {
        "variant": true
      }
    }
  ],
  "query": {
    "text_query": {
      "fields": [
        "id"
      ],
      "search_phrase": "my-product"
    }
  },
  "select": "**",
  "start": 0,
  "total": 2
}
```

### query

Document representing a query. A query contains a set of objects that define criteria used to select records. A query can contain one of the following:

*   match\_all\_query - returns all records.
    
*   term\_query - matches records where a field (or fields) exactly match some simple value (including null).
    
*   text\_query - matches records where a field (or fields) contain a search phrase.
    
*   boolean\_query - formulates a complex boolean expression using query objects as criteria.
    
*   filtered\_query - allows for filtering of records based on both a query and a filter.
    

Type: `any`.

### sort

Document representing a sort request.

*   `field` (_string_, required) The name of the field to sort on.
*   `sort_order` (_string_) The sort order to be applied when sorting. When omitted, the default sort order (ASC) is used.  
    Allowed values: `asc`, `desc`.

_Example_

```
{
  "field": "id",
  "sort_order": "asc"
}
```

### cause

*   `cause` (_cause_)
*   `message` (_string_)
*   `type` (_string_)

### product

Document representing a product

*   `assigned_categories` (_array of catalog\_category\_id_) The catalog categories that the product is assigned to
*   `ats` (_number (double)_) The ATS(Available To Sell) inventory value of the product. This is a calculated value.
*   `brand` (_string_) The brand of the product.
*   `bundled_products` (_array of product_) The array of bundled products which the product includes.
*   `classification_category` (_catalog\_category\_id_) The classification category (default category) of the product
*   `creation_date` (_string (date-time)_, read-only) Returns the value of attribute 'creationDate'.
*   `default_variant_id` (_string_) The ID of the product's default variant.
*   `ean` (_string_) The European Article Number of the product.
*   `id` (_string_) The ID (SKU) of the product.  
    Minimum length: 1. Maximum length: 100.
*   `image` (_media\_file_) The image(s) assigned to the product.
*   `image_groups` (_array of image\_group_) The array of product image groups.
*   `in_stock` (_boolean_) The flag that indicates if the product is in stock, or not. This is a calculated value.
*   `last_modified` (_string (date-time)_, read-only) Returns the value of attribute 'lastModified'.
*   `link` (_string_) A link to the product.
*   `localized_tax_class_id` (_object (localized)_)
    
    Additional properties: `string`.
    
*   `long_description` (_object (localized)_) The localized long description of the product.
    
    Additional properties: `markup_text`.
    
*   `manufacturer_name` (_string_) The name of the product's manufacturer.
*   `manufacturer_sku` (_string_) The SKU of the product's manufacturer.
*   `master` (_master_) The master of the product. This is applicable for product types "variation\_group" and "variant" only.
*   `name` (_object (localized)_) The localized name of the product.
    
    Additional properties: `string`.
    
*   `online` (_boolean_) The flag that indicates if the product is online, or not. This is a calculated value.
*   `online_flag` (_object (site-specific)_) The site specific online status of the product.
    
    Additional properties: `boolean`.
    
*   `owning_catalog_id` (_string_) The ID of the catalog that owns the product.
*   `owning_catalog_name` (_object (localized)_) The localized name of the catalog that owns the product.
    
    Additional properties: `string`.
    
*   `page_description` (_object (localized)_) The localized page description of the product.
    
    Additional properties: `string`.
    
*   `page_keywords` (_object (localized)_) The localized page keywords of the product.
    
    Additional properties: `string`.
    
*   `page_title` (_object (localized)_) The localized page title of the product.
    
    Additional properties: `string`.
    
*   `price` (_number (double)_) The price of the product.
*   `price_currency` (_string_) The currency code for product's price.
*   `price_per_unit` (_number (double)_) The price per unit of the product
*   `primary_categories` (_array of catalog\_category\_id_) The catalog categories that are primary for the product
*   `primary_category_id` (_string_) The id of the products primary category.
*   `product_bundles` (_array of product_) The array of product bundles which the product belongs to.
*   `product_options` (_array of product\_option_) The array of product options. This is applicable for products of type "option".
*   `product_sets` (_array of product_) The array of product sets which the product belongs to.
*   `searchable` (_object (site-specific)_) The site specific searchable status of the product.
    
    Additional properties: `boolean`.
    
*   `set_products` (_array of product_) The array of set products which the product includes.
*   `short_description` (_object (localized)_) The localized short description of the product.
    
    Additional properties: `markup_text`.
    
*   `tax_class_id` (_string_) The catalog categories that the product is assigned to
*   `type` (_product\_type_) The type of the product. It can have one or more of the values "item", "master", "variation\_group", "variant", "bundle", and "set".
*   `unit` (_string_) The sales unit of the product.
*   `unit_measure` (_string_) The unitMeasure of the product.
*   `unit_quantity` (_number (double)_) The unitQuantity of the product.
*   `upc` (_string_) The Universal Product Code of the product.
*   `valid_from` (_object (site-specific)_) The time when product is valid from.
    
    Additional properties: `string (date-time)`.
    
*   `valid_to` (_object (site-specific)_) The time when product is valid to.
    
    Additional properties: `string (date-time)`.
    
*   `variants` (_array of variant_) The array of variants of the product. This is applicable for product types "master" and "variation\_group" only.
*   `variation_attributes` (_array of variation\_attribute_) The sorted array of variation attributes assigned to the product. This is applicable for product types "master", "variation\_group" and "variant" only.
*   `variation_groups` (_array of variation\_group_) The array of variation groups in the product. This is applicable for product type "master" only.
*   `variation_values` (_object_)
    
    The variation values selected for the product in variation attribute id and value pairs. This is applicable for product types "variant" and "variation\_group" only.
    
    ```
         Only for type variant and variation group.
    ```
    
    Additional properties: `string`.
    

_Example_

```
{
  "ats": 500,
  "brand": "Brand",
  "ean": "EAN",
  "id": "my-product",
  "in_stock": true,
  "link": "https://example.com/s/-/dw/data/{version}/products/my-product",
  "long_description": {
    "default": "Long Description"
  },
  "manufacturer_name": "Manufacturer",
  "manufacturer_sku": "Manufacturer ID",
  "name": {
    "default": "My Product"
  },
  "online": true,
  "online_flag": {
    "default": true
  },
  "owning_catalog_id": "my-catalog",
  "owning_catalog_name": {
    "default": "My Catalog"
  },
  "page_description": {
    "default": "Page description"
  },
  "page_keywords": {
    "default": "Page Keyword"
  },
  "page_title": {
    "default": "Page title"
  },
  "price": 100,
  "price_currency": "USD",
  "price_per_unit": 100,
  "searchable": {
    "default": true
  },
  "short_description": {
    "default": "Short Description"
  },
  "type": {
    "bundle": true,
    "bundled": true,
    "part_of_product_set": true
  },
  "unit": "bnd",
  "unit_measure": "each",
  "unit_quantity": 1,
  "upc": "UPC"
}
```

### result\_page

Data that can be used to get the next and previous page of a Data API results object.

*   `count` (_integer (int32)_) The number of returned documents.
*   `db_start_record_` (_integer (int32)_) The zero-based index of the record that we want to start with, used to optimize special handling
*   `start` (_integer (int32)_) The zero-based index of the first search hit to include in the result.

### catalog\_category\_id

Document representing a catalog category id.

*   `catalog_id` (_string_) The id of the catalog that owns the category.  
    Minimum length: 1. Maximum length: 256.
*   `category_id` (_string_) The id of the category.  
    Minimum length: 1. Maximum length: 256.

### media\_file

*   `abs_url` (_string_) The absolute URL with request protocol (read only)
*   `alt` (_object (localized)_) The alternative image text
    
    Additional properties: `string`.
    
*   `dis_base_url` (_string_) The DIS base URL only for product images
*   `path` (_string_) The raw media file path (only this needs to be provided in update request)
*   `title` (_object (localized)_) The image title
    
    Additional properties: `string`.
    

_Example_

```
{
  "path": "option.jpg"
}
```

### image\_group

Document representing an image group containing a list of images for a particular view type and an optional variation value.

*   `images` (_array of media\_file_) The images of the image group.
*   `variation_attributes` (_array of variation\_attribute_) Returns a list of variation attributes applying to this image group.
*   `view_type` (_string_) The image view type.

### markup\_text

*   `markup` (_string_) The rendered HTML (read only)
*   `source` (_string_) The raw markup text (only this needs to be provided in update request)

### master

Document representing a variation master.

*   `link` (_string_) The URL addressing the master product.
*   `master_id` (_string_, required) The id (SKU) of the master product.  
    Minimum length: 1. Maximum length: 100.
*   `orderable` (_boolean_) A flag indicating whether at least one of the variants is orderable.
*   `price` (_number (double)_) The minimum sales price of the related variants.
*   `price_max` (_number (double)_) The maximum sales of related variants.
*   `price_per_unit` (_number (double)_) The minimum sales price per unit of the related variants.
*   `price_per_unit_max` (_number (double)_) The maximum sales price per unit of the related variants.
*   `prices` (_object_)
    
    Additional properties: `number (double)`.
    

### product\_option

Document representing a product option

*   `custom_name` (_object (localized)_) The localized custom name of the product option.
    
    Additional properties: `string`.
    
*   `default_product_option_value` (_string_) The default product option value.
*   `description` (_object (localized)_) The localized description of the product option.
    
    Additional properties: `string`.
    
*   `id` (_string_) The object attribute definition id which is also the identifier for the product option.  
    Minimum length: 1.
*   `image` (_media\_file_) The image assigned to the product option.
*   `link` (_string_) The URL link to the product option.
*   `name` (_string_) The name of the object attribute definition.
*   `selected_option_value` (_string_) The selected option value of the product option.
*   `shared` (_boolean_) The flag that indicates if the product option is shared or local.
*   `sorting_mode` (_string_) The sorting mode for the product option values.  
    Allowed values: `byexplicitorder`, `byoptionprice`.
*   `values` (_array of product\_option\_value_) The sorted array of values of the product option.

_Example_

```
{
  "custom_name": {
    "default": "Option 15"
  },
  "description": {
    "default": "Description for Option 15"
  },
  "id": "option15",
  "image": {
    "abs_url": "https://example.com/on/demandware.static/-/Sites-my-catalog/default/vc8f08a6edba0d7c8e1dec6c535661e44154b54b4/Desert.jpg",
    "dis_base_url": "https://example.com/dw/image/v2/zzzz_s01/on/demandware.static/-/Sites-my-catalog/default/vc8f08a6edba0d7c8e1dec6c535661e44154b54b4/Desert.jpg",
    "path": "Desert.jpg"
  },
  "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/option15",
  "name": "15",
  "shared": true,
  "sorting_mode": "byoptionprice",
  "values": [
    {
      "id": "10",
      "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/option15/Values/10",
      "option_price": {
        "USD": "9.99"
      },
      "sku_extension": "12",
      "value": {
        "default": "12"
      }
    },
    {
      "id": "121",
      "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/option15/Values/121",
      "option_price": {
        "USD": "19.99"
      },
      "sku_extension": "12",
      "value": {
        "default": "12"
      }
    }
  ]
}
```

### product\_type

Document representing a product type.

*   `bundle` (_boolean_) A flag indicating whether the product is a bundle.
*   `bundled` (_boolean_) A flag indicating whether the product is bundled.
*   `item` (_boolean_) A flag indicating whether the product is a standard item.
*   `master` (_boolean_) A flag indicating whether the product is a master.
*   `option` (_boolean_) A flag indicating whether the product is an option.
*   `part_of_product_set` (_boolean_) A flag indicating whether the product is part of product set.
*   `part_of_retail_set` (_boolean_) A flag indicating whether the product is part of retail set.
*   `retail_set` (_boolean_) A flag indicating whether the product is a retail set.
*   `set` (_boolean_) A flag indicating whether the product is a set.
*   `variant` (_boolean_) A flag indicating whether the product is a variant.
*   `variation_group` (_boolean_) A flag indicating whether the product is a variation group.

_Example_

```
{
  "bundled": true,
  "master": true,
  "part_of_product_set": true
}
```

### variant

Document representing a product variation.

*   `ats` (_number (double)_) Inventory "Available to Sell" of the product.
*   `default_product_variation` (_boolean_)
*   `image` (_media\_file_) URL to the preview image.
*   `in_stock` (_boolean_) `true` if the product is in stock, or `false` if not.
*   `link` (_string_) The URL addressing the product.
*   `online` (_boolean_) If the product is currently online. `true` if online `false` if not
*   `orderable` (_boolean_) A flag indicating whether the variant is orderable.
*   `price` (_number (double)_) The sales price of the variant.
*   `price_currency` (_string_) Currency code for the price of the product.
*   `price_per_unit` (_number (double)_) The sales price of the variant.
*   `product_id` (_string_, required) The id (SKU) of the variant.  
    Minimum length: 1. Maximum length: 100.
*   `searchable` (_object (site-specific)_)
    
    Additional properties: `boolean`.
    
*   `variation_attributes` (_array of variation\_attribute_) variation attributes
*   `variation_values` (_object_) The actual variation attribute id - value pairs.
    
    Additional properties: `string`.
    

_Example_

```
{
  "link": "https://ocapi-mon.example.com/s/-/dw/data/{version}/products/dress-spring-red",
  "product_id": "dress-spring-red",
  "variation_values": {
    "color": "red"
  }
}
```

### variation\_attribute

Document representing a variation attribute.

*   `attribute_definition_id` (_string_, required) The id of the requested attribute definition.
*   `attribute_definition_name` (_object (localized)_) The localized display name of the variation attribute definition.
    
    Additional properties: `string`.
    
*   `default_value` (_string_) default variation attribute value
*   `id` (_string_) The id of the variation attribute.  
    Minimum length: 1.
*   `link` (_string_) URL that is used to get this instance
*   `name` (_object (localized)_) The localized display name of the variation attribute.
    
    Additional properties: `string`.
    
*   `shared` (_boolean_) Returns the value of attribute 'shared' if attribute is local or shared
*   `slicing` (_boolean_) Returns the value of attribute 'slicing'.
*   `values` (_array of variation\_attribute\_value_) The sorted array of variation values. This array can be empty.
*   `variation_attribute_type` (_string_) variation attribute type  
    Allowed values: `string`, `int`, `unknown`.

_Example_

```
{
  "id": "fabric",
  "name": {
    "default": "Fabric"
  },
  "values": [
    {
      "name": {
        "default": "Leather"
      },
      "value": "leather"
    },
    {
      "name": {
        "default": "Linen"
      },
      "value": "linen"
    },
    {
      "name": {
        "default": "Plastic"
      },
      "value": "plastic"
    },
    {
      "name": {
        "default": "Metal"
      },
      "value": "metal"
    }
  ]
}
```

### variation\_group

Document representing a variation group.

*   `link` (_string_) The URL addressing the product.
*   `orderable` (_boolean_) A flag indicating whether the variation group is orderable.
*   `price` (_number (double)_) The sales price of the variation group.
*   `price_per_unit` (_number (double)_) The sales price per unit of the variation group.
*   `product_id` (_string_) The id (SKU) of the variation group.  
    Minimum length: 1. Maximum length: 100.
*   `variation_values` (_object_) The actual variation attribute id - value pairs.
    
    Additional properties: `string`.
    

_Example_

```
{
  "link": "https://example.com/s/-/dw/data/{version}/products/my-product-5",
  "product_id": "my-product-5",
  "variation_values": {
    "color": "red"
  }
}
```

### product\_option\_value

Document representing a product option Value

*   `default_product_option_value` (_boolean_) Flag indicating if the product option value is the default value for the product option.
*   `id` (_string_) The id of the product option value.  
    Minimum length: 1.
*   `link` (_string_) The URL link to the product option value.
*   `option_prices` (_array of money_) The list of prices in the product option value.
*   `sku_extension` (_string_) The sku extension of the product option value.
*   `value` (_object (localized)_) The localized value of the product option.
    
    Additional properties: `string`.
    

_Example_

```
{
  "default_product_option_value": false,
  "id": "value3",
  "link": "https://example.com/s/-/dw/data/{version}/catalogs/my-catalog/shared_product_options/my-option/values/S02",
  "option_prices": [
    {
      "currency_mnemonic": "USD",
      "value": 19.99
    }
  ],
  "sku_extension": "S02",
  "value": {
    "default": "2-year",
    "en": "2-year (en)"
  }
}
```

### variation\_attribute\_value

Document representing a variation attribute value.

*   `description` (_object (localized)_) The localized description of the variation value.
    
    Additional properties: `string`.
    
*   `image` (_media\_file_) The first product image for the configured viewtype and this variation value.
*   `image_swatch` (_media\_file_) The first product image for the configured viewtype and this variation value. (typically the swatch image)
*   `link` (_string_)
*   `name` (_object (localized)_) The localized display name of the variation value.
    
    Additional properties: `string`.
    
*   `orderable` (_boolean_) A flag indicating whether at least one variant with this variation attribute value is available to sell.
*   `position` (_number (double)_) The position of the value among all values of a variation attribute.
*   `value` (_string_, required) The actual variation value.  
    Minimum length: 1.

_Example_

```
{
  "name": {
    "default": "Leather"
  },
  "value": "leather"
}
```

### money

*   `currency_mnemonic` (_string_) The mnemonic for the money.
*   `value` (_number (double)_) The value for the money.

_Example_

```
{
  "currency_mnemonic": "USD",
  "value": 100
}
```

### bool\_filter

Document representing a boolean filter.

A boolean filter allows you to combine other filters into (possibly recursive) logical expression trees. A boolean filter is configured with a boolean operator (AND, OR, NOT) and a list of filters the operator relates to. If multiple filters are given to a boolean NOT operator, this is interpreted as a NOT upon a boolean OR of the given filters.

**Example:** (id="myId" AND coupon\_id="couponOne")

query: {
filtered\_query: {
query: { match\_all\_query: {} },
filter: {
bool\_filter: {
operator: "and",
filters: \[
{ term\_filter: { field: "id", operator: "is", values: \["myId"\] } },
{ term\_filter: { field: "coupon\_id", operator: "is", values: \["couponOne"\] } }
\]
}
}
}
}

**Example:** (id="holidaySale" OR redemption\_count BETWEEN(1, 20)

query: {
filtered\_query: {
query: { match\_all\_query: {} },
filter: {
bool\_filter: {
operator: "or",
filters: \[
{ term\_filter: { field: "id", operator: "is", values: \["holidaySale"\] } },
{ range\_filter: { field: "redemption\_count", from: 1, to: 20 } }
\]
}
}
}
}

**Example:** NOT(enabled=false OR coupon\_id="special")

query: {
filtered\_query: {
query: { match\_all\_query: {} },
filter: {
bool\_filter: {
operator: "not",
filters: \[
{ term\_filter: { field: "enabled", operator: "is", values: \[false\] } },
{ term\_filter: { field: "coupon\_id", operator: "is", values: \["special"\] } }
\]
}
}
}
}

*   `filters` (_array of filter_) A list of filters, which are logically combined by an operator.
*   `operator` (_string_, required) The logical operator the filters are combined with.  
    Allowed values: `and`, `or`, `not`.

### bool\_query

A boolean query allows construction of full logical expression trees consisting of other queries (usually term and text queries). A boolean query basically has 3 sets of clauses that 'must', 'should' and / or 'must not' match. If 'must', 'must\_not', or 'should' appear in the same boolean query, they are combined logically using the AND operator. The difference between must and should operators is that the must operator requires all subqueries to match whereas the should operator only requires one match

**Example:** (id = 'foo' AND description LIKE 'bar')

query: {
bool\_query: {
must: \[
{ term\_query: { fields: \["id"\], operator: "is", values: \["foo"\] } },
{ text\_query: { fields: \["description"\], search\_phrase: "bar" } }
\]
}
}

**Example:** (id = 'foo' OR description LIKE 'bar')

query: {
bool\_query: {
should: \[
{ term\_query: { fields: \["id"\], operator: "is", values: \["foo"\] } },
{ text\_query: { fields: \["description"\], search\_phrase: "bar" } }
\]
}
}

**Example:** (NOT (id = 'foo' AND description LIKE 'bar'))

query: {
bool\_query: {
must\_not: \[
{ term\_query: { fields: \["id"\], operator: "is", values: \["foo"\] } },
{ text\_query: { fields: \["description"\], search\_phrase: "bar" } }
\]
}
}

**Example:** ((coupon\_id LIKE "limit" AND description LIKE "limit per customer") AND NOT (enabled=false))

query: {
bool\_query: {
must: \[
{ text\_query: { fields: \[ "coupon\_id" \], search\_phrase: "limit" } },
{ text\_query: { fields: \[ "description" \], search\_phrase: "limit per customer" } }
\],
must\_not: \[
{ term\_query: { fields: \[ "enabled" \], operator: "is", values: \[false\] } }
\]
}
}

*   `must` (_array of query_) List of queries that must match.
*   `must_not` (_array of query_) List of queries that must not match.
*   `should` (_array of query_) List of queries that should match (i.e., at least one query must match).

### filter

Document representing a filter.

A filter contains a set of objects that define criteria used to select records. A filter can contain one of the following:

*   term\_filter - matches records where a field (or fields) exactly match some simple value (including null).
    
*   range\_filter - matches records where a field value lies in a specified range.
    
*   query\_filter - provides filtering based on a query.
    
*   bool\_filter - provides filtering of records using a set of filters combined with a specified operator.
    

Type: `any`.

### filtered\_query

A filtered query allows to filter the result of a (possibly complex) query using a (possibly complex) filter.

**Example:**

query : {
filtered\_query: {
query: {
text\_query: { fields: \["coupon\_id"\], search\_phrase: "disabled" }
},
filter: {
term\_filter: {
field: "enabled", operator: "is", values: \[ false \]
}
}
}
}

*   `filter` (_filter_, required) The (possibly complex) filter object.
*   `query` (_query_, required) The query object.

### match\_all\_query

A match all query simply matches all documents (namespace and document type). This query comes in handy if you just want to filter a search result or really do not have any constraints.

**Example:**

query: {
match\_all\_query: {}
}

Type: `any`.

### nested\_query

A nested query queries nested documents that are part of a larger document. The classical example is a product master with variants (in one big document) where you want to constrain a search to masters that have variants that match multiple constraints (like color = blue AND size = M). This query is not compatible with some search types. **Example:** finds all the documents that has firstname = "John" and lastname = "Doe"

{
"query": {
"bool\_query": {
"must": \[
{
"nested\_query": {
"path": "order.shipping\_addresses",
"query": {
"bool\_query": {
"must": \[
{
"bool\_query": {
"must": \[
{
"term\_query": {
"fields": \[ "order.shipping\_addresses.first\_name" \],
"operator": "is",
"values": \[ "John" \]
}
}
\]
}
},
{
"bool\_query": {
"must": \[
{
"term\_query": {
"fields": \[ "order.shipping\_addresses.last\_name" \],
"operator": "is",
"values": \[ "Doe" \]
}
}
\]
}
}
\]
}
},
"score\_mode": "avg"
}
}
\]
}
}
}

*   `path` (_string_, required)
*   `query` (_query_, required)
*   `score_mode` (_string_)  
    Allowed values: `avg`, `total`, `max`, `none`.

### query\_filter

Document representing a query filter. A query filter wraps any query and allows it to be used as a filter.

**Example:** (coupon\_id contains "disabled" AND (enabled=false OR active=false))

query : {
filtered\_query: {
query: { text\_query: { fields: \["coupon\_id"\], search\_phrase: "disabled" } },
filter: {
query\_filter: {
query: {
term\_query: { fields: \["enabled","active"\], operator: "is", values: \[ false \] }
}
}
}
}
}

*   `query` (_query_, required) The query to use as a filter.

### range2\_filter

Document representing a range comparison with a range filter, named Range2Filter.

A Range2Filter allows you to restrict a search result to hits where a range defined by specified attributes has a certain relationship to a specified range.

The first range (R1) is defined by a pair of attributes ("from\_field" and "to\_field") that specify the extent of a range, such as the attributes "valid\_from" and "valid\_to".

The second range (R2) is defined by "from\_value" and "to\_value".

The filter mode specifies the method used to compare the two ranges:

*   overlap: R1 overlaps fully or partially with R2
    
*   containing: R1 contains R2
    
*   contained: R1 is contained in R2
    

The range filter supports several value types, and relies on the natural sorting of the value type for range interpretation. Value ranges can be open-ended (at one end only). You can configure whether the lower and upper bounds are inclusive or exclusive.

A range 2 filter is useful for general restrictions that can be shared between searches (like a static date range) because the filter result is cached in memory. Range filters are not appropriate if the range is expected to be different for every query (for example, if the user controls the date range down to the hour via a UI control). Range filters are inclusive by default.

**Example:** (valid dates overlap with the range January 1, 2007 through January 1, 2017)

"query" : {
"filtered\_query": {
"filter": {
"range2\_filter": {
"from\_field": "valid\_from",
"to\_field": "valid\_to",
"filter\_mode":"overlap",
"from\_value": "2007-01-01T00:00:00.000Z",
"to\_value": "2017-01-01T00:00:00.000Z"
}
},
"query": { "match\_all\_query": {} }
}
}

*   `filter_mode` (_string_) Compare mode: overlap, containing, or contained. If not specified, the default is overlap.  
    Allowed values: `overlap`, `containing`, `contained`.
*   `from_field` (_string_, required) The field name of the field that starts the first range.
*   `from_inclusive` (_boolean_) Indicates whether the lower bound of the second range is inclusive. If not specified, the default is true. Set to false to make the lower bound exclusive.
*   `from_value` (_object_) The lower bound of the second range. If not specified, the range is open-ended with respect to the lower bound. You can't leave both the lower and upper bounds open-ended.
*   `to_field` (_string_, required) The field name of the field that ends the first range.
*   `to_inclusive` (_boolean_) Indicates whether the upper bound of the second range is inclusive. If not specified, the default is true. Set to false to make the lower bound exclusive.
*   `to_value` (_object_) The upper bound of the second range. If not specified, the range is open-ended with respect to the upper bound. You can't leave both the upper and lower bounds open-ended.

### range\_filter

Document representing a range filter.

A range filter allows you to restrict a search result to hits that have values for a given attribute that fall into a given value range. The range filter supports several value types, and relies on the natural sorting of the value type for range interpretation. Value ranges can be open-ended (at one end only). You can configure whether the lower and upper bounds are inclusive or exclusive.

A range filter is useful for general restrictions that can be shared between searches (like a static date range) because the filter result is cached in memory. Range filters are not appropriate if the range is expected to be different for every query (for example, if the user controls the date range down to the hour via a UI control). Range filters are inclusive by default.

**Example:** ( redemption\_count BETWEEN (0,10\] )

query: {
filtered\_query: {
query: { match\_all\_query: {} },
filter: {
range\_filter: {
field: "redemption\_count",
from: 0,
to: 10,
from\_inclusive: false
}
}
}
}

*   `field` (_string_, required) The search field.
*   `from` (_object_) The lower bound of the filter range. If not specified, the range is open-ended with respect to the lower bound. You can't leave both the lower and upper bounds open-ended.
*   `from_inclusive` (_boolean_) Indicates whether the lower bound of the range is inclusive. If not specified, the default is true. Set to false to make the lower bound exclusive.
*   `to` (_object_) The upper bound of the filter range. If not specified, the range is open-ended with respect to the upper bound. You can't leave both the upper and lower bounds open-ended.
*   `to_inclusive` (_boolean_) Indicates whether the upper bound of the range is inclusive. If not specified, the default is true. Set to false to made the upper bound exclusive.

### term\_filter

Document representing a term filter.

A term filter allows you to restrict a search result to hits that match (exactly) one of the values configured for the filter. A term filter is useful for general restrictions that can be shared between searches. Use term filters whenever the criterion you filter on is a shared property of multiple searches (for example, like filtering by an order status). Use term filters for fields that have a discrete and small set of values only.

**Example:** (id="my\_id")

query: {
filtered\_query: {
query: { match\_all\_query: {} },
filter: {
term\_filter: {
field: "id",
operator: "is",
values: \["my\_id"\]
}
}
}
}

**Example:** (id IN ("my\_id","other\_id"))

query: {
filtered\_query: {
query: { match\_all\_query: {} },
filter: {
term\_filter: {
field: "id",
operator: "one\_of",
values: \["my\_id","other\_id"\]
}
}
}
}

**Example:** (description=NULL)

query: {
filtered\_query: {
query: { match\_all\_query: {} },
filter: {
term\_filter: {
field: "description",
operator: "is\_null"
}
}
}
}

*   `field` (_string_, required) The filter field.
*   `operator` (_string_, required) The operator to compare the field's values with the given ones.  
    Allowed values: `is`, `one_of`, `is_null`, `is_not_null`, `less`, `greater`, `not_in`, `neq`.
*   `values` (_array of object_) The filter values.

### term\_query

A term query matches one (or more) value(s) against one (or more) document field(s). A document is considered a hit if one of the values matches (exactly) with at least one of the given fields. The operator "is" can only take one value, while "one\_of" can take multiple values. If multiple fields are specified, they are combined using the OR operator. The `less` and `greater` operators are not compatible with some search types. To query based on numeric bounds in those cases, you can use a range filter on a filtered query .

**Elastic only** : If used with multiple fields, the query is internally handled as a boolean OR of DisjointMaxQueries (with the dismax matching a value against all fields). The dismax makes sure that a document carrying a single term in multiple fields does not get higher scores than a document matching multiple terms in multiple fields.

**Example:** (id="my\_id")

query: {
term\_query: {
fields: \["id"\],
operator: "is",
values: \["my\_id"\]
}
}

**Example:** (id IN ("my\_id","other\_id"))

query: {
term\_query: {
fields: \["id"\],
operator: "one\_of",
values: \["my\_id","other\_id"\]
}
}

**Example:** (id=null)

query: {
term\_query: {
fields: \["description"\],
operator: "is\_null"
}
}

**Example:** ((id IN ('generic', 'keyword')) OR (description IN ('generic', 'keyword'))

query: {
term\_query: {
fields: \["id", "description"\],
operator: "one\_of",
values: \["generic","keyword"\]
}
}

*   `fields` (_array of string_, required) The document field(s) the value(s) are matched against, combined with the operator.  
    Minimum items: 1.
*   `operator` (_string_, required) Returns the operator to use for the term query.  
    Allowed values: `is`, `one_of`, `is_null`, `is_not_null`, `less`, `greater`, `not_in`, `neq`.
*   `values` (_array of object_) The values the field(s) are compared against, combined with the operator.

### text\_query

A text query is used to match some text (i.e. a search phrase possibly consisting of multiple terms) against one or multiple fields. In case multiple fields are provided, the phrase conceptually forms a logical OR over the fields. In this case, the terms of the phrase basically have to match the text that would result from concatenating all given fields.

**Example:** (coupon\_id contains "xmas" )

query: {
text\_query: {
fields: \["coupon\_id"\],
search\_phrase: "xmas"
}
}

**Example:** (coupon\_id contains "xmas" OR description contains "xmas")

query: {
text\_query: {
fields: \["description", "coupon\_id"\],
search\_phrase: "xmas"
}
}

**Example:** (description contains "holiday" AND description contains "bojo")

query: {
text\_query: {
fields: \["description"\],
search\_phrase: "holiday bogo"
}
}

*   `fields` (_array of string_, required) The document fields the search phrase has to match.  
    Minimum items: 1.
*   `search_phrase` (_string_, required) A search phrase which may consist of multiple terms.